package cn.com.ctop.kuaishou.modules.material.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.com.ctop.kuaishou.modules.material.entity.ProjectPictureLibrary;
import cn.com.ctop.kuaishou.modules.material.service.IProjectPictureLibraryService;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

 /**
 * 项目图片库
 * @author jeecg-boot
 * @date   2022-05-05
 * @version V1.0
 */
@Slf4j
@Api(tags="项目图片库")
@RestController
@RequestMapping("/project/pictureLibrary")
public class ProjectPictureLibraryController {
	@Autowired
	private IProjectPictureLibraryService projectPictureLibraryService;

	/**
	  * 分页列表查询
	 * @param projectPictureLibrary
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@ApiOperation(value="项目奖图片库-分页列表查询", notes="项目奖图片库-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ProjectPictureLibrary>> queryPageList(ProjectPictureLibrary projectPictureLibrary,
															  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
															  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
															  HttpServletRequest req) {
		Result<IPage<ProjectPictureLibrary>> result = new Result<>();
		QueryWrapper<ProjectPictureLibrary> queryWrapper = QueryGenerator.initQueryWrapper(projectPictureLibrary, req.getParameterMap());
		Page<ProjectPictureLibrary> page = new Page<ProjectPictureLibrary>(pageNo, pageSize);
		IPage<ProjectPictureLibrary> pageList = projectPictureLibraryService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}

	/**
	  *   添加
	 */
	@ApiOperation(value="项目图片库-添加", notes="项目奖图片库-添加")
	@PostMapping(value = "/add")
	public Result<Object> add(@RequestBody ProjectPictureLibrary projectPictureLibrary) {
		try {
			return projectPictureLibraryService.add(projectPictureLibrary);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
			return Result.error("操作失败");
		}
	}

	/**
	  *  编辑
	 * @param projectPictureLibrary
	 * @return
	 */
	@ApiOperation(value="项目奖图片库-编辑", notes="项目奖图片库-编辑")
	@PutMapping(value = "/edit")
	public Result<ProjectPictureLibrary> edit(@RequestBody ProjectPictureLibrary projectPictureLibrary) {
		Result<ProjectPictureLibrary> result = new Result<ProjectPictureLibrary>();
		ProjectPictureLibrary projectPictureLibraryEntity = projectPictureLibraryService.getById(projectPictureLibrary.getId());
		if(projectPictureLibraryEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = projectPictureLibraryService.updateById(projectPictureLibrary);
			if(ok) {
				result.success("修改成功!");
			}
		}

		return result;
	}

	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@ApiOperation(value="项目奖图片库-通过id删除", notes="项目奖图片库-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id") String id) {
		try {
			projectPictureLibraryService.removeById(id);
		} catch (Exception e) {
			log.error("删除失败",e.getMessage());
			return Result.error("删除失败!");
		}
		return Result.ok("删除成功!");
	}

	/**
	 *  批量删除
	 * @param ids
	 * @return
	 */
	@ApiOperation(value="项目奖图片库-批量删除", notes="项目奖图片库-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<ProjectPictureLibrary> deleteBatch(@RequestParam(name="ids") String ids) {
		Result<ProjectPictureLibrary> result = new Result<>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.projectPictureLibraryService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}

	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@ApiOperation(value="项目奖图片库-通过id查询", notes="项目奖图片库-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ProjectPictureLibrary> queryById(@RequestParam(name="id",required=true) String id) {
		Result<ProjectPictureLibrary> result = new Result<>();
		ProjectPictureLibrary projectPictureLibrary = projectPictureLibraryService.getById(id);
		if(projectPictureLibrary==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(projectPictureLibrary);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<ProjectPictureLibrary> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              ProjectPictureLibrary projectPictureLibrary = JSON.parseObject(deString, ProjectPictureLibrary.class);
              queryWrapper = QueryGenerator.initQueryWrapper(projectPictureLibrary, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<ProjectPictureLibrary> pageList = projectPictureLibraryService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "项目奖图片库列表");
      mv.addObject(NormalExcelConstants.CLASS, ProjectPictureLibrary.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("项目奖图片库列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<ProjectPictureLibrary> listProjectPictureLibrarys = ExcelImportUtil.importExcel(file.getInputStream(), ProjectPictureLibrary.class, params);
              projectPictureLibraryService.saveBatch(listProjectPictureLibrarys);
              return Result.ok("文件导入成功！数据行数:" + listProjectPictureLibrarys.size());
          } catch (Exception e) {
              log.error(e.getMessage(),e);
              return Result.error("文件导入失败:"+e.getMessage());
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
